#include <string.h>
#include "ringbuffer.h"
static int *in_ptr = NULL, *out_ptr = NULL;

static volatile int bufcnt = 0;

static int key_buffer[BUF_ELEMENTS];

void key_buf_init ()
{
  memset (key_buffer, 0, sizeof (key_buffer));
  bufcnt = 0;
  out_ptr = key_buffer;
  in_ptr = key_buffer;

}

/* return bufcnt if OK and NULL on error */
int key_put_buf (int key)
{
  if (bufcnt < BUF_ELEMENTS)    // If buffer not full
   {
     *in_ptr = key;
     in_ptr++;                  // Increment pointer
     bufcnt++;
     if (in_ptr >= (key_buffer + BUF_ELEMENTS))
       in_ptr = key_buffer;
   }
  else
    return 0;

  return bufcnt;
}

/* returns 0 if queue is empty and current bufcnt if not */
int key_get_buf (int *key)
{

  if (!bufcnt)
    return 0;

  *key = *out_ptr;
  *out_ptr = 0;
  out_ptr++;
  if (out_ptr >= (key_buffer + BUF_ELEMENTS))
    out_ptr = key_buffer;
  bufcnt--;                     // Decrement buffer count
  return bufcnt + 1;
}

int key_getbufcnt ()
{
  return bufcnt;
}
